//////////////////////////////////////////////////////////////////////////
// TSXtruder 1.0 by Bendy's 3D Systems
// Copyright (c) 1999
//
// Based on Extruder 1.1 by Bryce Denney
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// The complete GNU public license can be found in this directory.
//
//////////////////////////////////////////////////////////////////////////
// TSXtruder 1.0
// 
// Truespace 3.x extension
// 
// Takes a 24/16 bit uncompressed TGA file and
// creates a heightfield object by extruding the
// top face of a cube relative to the intensity values
// in the TGA image.

// ExtrudeTSX.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "ExtrudeTSX.h"
#include "tga.h"
#include "TSXDialog.h"
#include "TSXAboutDialog.h"
#include "tsx.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CExtrudeTSXApp

BEGIN_MESSAGE_MAP(CExtrudeTSXApp, CWinApp)
	//{{AFX_MSG_MAP(CExtrudeTSXApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExtrudeTSXApp construction

CExtrudeTSXApp::CExtrudeTSXApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CExtrudeTSXApp object

CExtrudeTSXApp theApp;
// and the about box
CTSXAboutDialog about;

// we ain't active
BOOL CExtrudeTSXApp::sm_bIsActive = FALSE;

int g_tsxid=0;

// tsxGetData, gives a little info about the plugin
int tsxGetData( tsxData* tsx_data, int tsxid )
{
    static tsxData MyTsxData = {
	"TSXtruder 1.0",
	"Bendy's 3D Systems",
	IDB_BITMAP_32,
	IDS_IDSTRING
    };

    *tsx_data = MyTsxData;

    // Save tsxid for this extension, for use with Callback functions.
    g_tsxid = tsxid;

    return tsxPLUG_DONE;
}

// Function type for Left-click on Xtension button.
int tsxOnLeftClick(void)
{
    //Put at beginning of exported fns, in a DLL using shared MFC DLL.
    AFX_MANAGE_STATE(AfxGetStaticModuleState( )); 

    // Show parameters dialog
    theApp.ShowDialog();

    // Activate
    CExtrudeTSXApp::SetActive();

	// Actually, this return value is a lie. The plugin
	// stays active. If I don't do this the plugin 
	// closes when I click on the delete button.
	// Anyone know why, and another way to get around
	// it.
    return tsxPLUG_DONE;
}

// Called when the plugin deactivates
void tsxDeactivate(void)
{
    //Put at beginning of exported fns, in a DLL using shared MFC DLL.
    AFX_MANAGE_STATE(AfxGetStaticModuleState( ));

    // NOTE: On exiting trueSpace, `CWinApp::ExitInstance' is called before
    //   tsxDeactivate (if the eXtension was active on exiting).
    //   We want to prevent tsxDeactivate from accessing theApp in this case.

    // Remove the window, if still around
    if ( CExtrudeTSXApp::IsActive() )
    {
	CExtrudeTSXApp::UnsetActive();
	theApp.HideDialog();
    }
}

// Show us the about box
void tsxOnRightClick(void)
{
    //Put at beginning of exported fns, in a DLL using shared MFC DLL.
    AFX_MANAGE_STATE(AfxGetStaticModuleState( )); 

//    theApp.ShowDialog();
	about.DoModal();
}

// Starts up the dialog box
BOOL CExtrudeTSXApp::InitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class

    m_pDlg = new CTSXDialog();
	
	return CWinApp::InitInstance();
}

// Shuts it down
int CExtrudeTSXApp::ExitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class

    // NOTE: On exiting trueSpace, `ExitInstance' is called before
    //   tsxDeactivate (if the eXtension was active on exiting).
    //   We want to prevent tsxDeactivate from accessing theApp in this case.

    // Deactivate
    UnsetActive();

    delete m_pDlg; //destroys window if not already

    return CWinApp::ExitInstance();
}

// Displays the dialog box
void CExtrudeTSXApp::ShowDialog()
{
    //Open Dialog if not already (i.e. if it doesn't have a window)
    if (m_pDlg->GetSafeHwnd() == 0)
    {
	m_pDlg->Create(); //Displays the Dialog window
    }
}

// Hides the dialog box
void CExtrudeTSXApp::HideDialog()
{
    if ( m_pDlg->GetSafeHwnd() )
	m_pDlg->DestroyWindow();
}

// Pointer to the dialog box
CTSXDialog* CExtrudeTSXApp::GetDialog()
{
	return m_pDlg;
}


