//////////////////////////////////////////////////////////////////////////
// TSXtruder 1.0 by Bendy's 3D Systems
// Copyright (c) 1999
//
// Based on Extruder 1.1 by Bryce Denney
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// The complete GNU public license can be found in this directory.
//
//////////////////////////////////////////////////////////////////////////
#if !defined(AFX_TSXDIALOG_H__3F0E6801_5D50_11D1_8132_000001069287__INCLUDED_)
#define AFX_TSXDIALOG_H__3F0E6801_5D50_11D1_8132_000001069287__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// TSXDialog.h : header file
//

// TSX data types we need (from tsx.h)
struct tsxGNODE; 

// Defines

/////////////////////////////////////////////////////////////////////////////
// CTSXDialog dialog

class CTSXDialog : public CDialog
{
// Construction
public:
	void SetProgress(int val);
	CTSXDialog(void);   // standard constructor
	BOOL Create();
	void OnCancel();

	
	void UpdateFileOut(CString);
protected:
	void calcFaces(void);
	void checkSmoothing(void);	

private:
// Dialog Data
	//{{AFX_DATA(CTSXDialog)
	enum { IDD = IDD_DIALOG };
	CProgressCtrl	m_progress_bar;
	UINT	m_xres;		// # of vertices in x
	UINT	m_yres;		// # of vertices in y
	UINT	m_nfaces;	// # of faces in object
	float	m_base;		// Base height
	float	m_height;	// Heightfield height
	CString	m_filename_out;	// filename output box
	CString filename;		// name of TGA file
	TGAfile tga;			// TGA file to be extruded
	BOOL	m_texture;
	BOOL	m_bump;
	float	m_xsize;
	float	m_ysize;
	BOOL	m_smooth;
	double	m_smooth_fac;
	BOOL	m_locksize;
	BOOL	m_lockres;
	//}}AFX_DATA
	BOOL	valid_file;		// True if there is a valid
							// TGA file in tga.
	int		m_face_type;	// Type of faces
	UINT	max_x,max_y;	// max x and y vals
	float	size_ratio;		// ratio of sizes for lock (x/y)
	float	res_ratio;		// ratio of sizes for res (x/y)
	
	bool	changing_res;
	bool	changing_size;
	CBitmapButton	xr_plus,xr_minus; // X Res Buttons
	CBitmapButton	yr_plus,yr_minus; // Y res buttons
	CBitmapButton	xs_plus,xs_minus;
	CBitmapButton	ys_plus,ys_minus;
	CBitmapButton	pz_plus,pz_minus;
	CBitmapButton	mz_plus,mz_minus;
	CBitmapButton	extrude, del, save;

	RECT	client_rect;
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTSXDialog)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

	BOOL OnInitDialog();
// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CTSXDialog)
	afx_msg void OnMake();
	afx_msg void OnDelete();
	afx_msg void OnGetFile();
	afx_msg void OnRadioTriangle();
	afx_msg void OnRadioPlane();
	afx_msg void OnRadioSemi();
	afx_msg void OnLocksize();
	afx_msg void OnLockres();
	afx_msg void OnChangeY();
	afx_msg void OnChangeX();
	afx_msg void OnXrminus();
	afx_msg void OnXrplus();
	afx_msg void OnMzsminus();
	afx_msg void OnMzsplus();
	afx_msg void OnPzsminus();
	afx_msg void OnPzsplus();
	afx_msg void OnXsminus();
	afx_msg void OnXsplus();
	afx_msg void OnYrminus();
	afx_msg void OnYrplus();
	afx_msg void OnYsminus();
	afx_msg void OnYsplus();
	afx_msg void OnChangeXsize();
	afx_msg void OnChangeYsize();
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TSXDIALOG_H__3F0E6801_5D50_11D1_8132_000001069287__INCLUDED_)
